'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getError = require('./get-error');

var _getError2 = _interopRequireDefault(_getError);

var _validatorjs = require('validatorjs');

var _validatorjs2 = _interopRequireDefault(_validatorjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = function (_React$Component) {
  _inherits(Form, _React$Component);

  function Form(_ref) {
    var initialValues = _ref.initialValues;

    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this));

    _this.state = { values: initialValues || {}, errors: {} };
    _this.onChange = _this.onChange.bind(_this);
    _this.validate = _this.validate.bind(_this);
    _this.validateOnBlurOrChange = _this.validateOnBlurOrChange.bind(_this);
    return _this;
  }

  _createClass(Form, [{
    key: 'validate',
    value: function validate(onClick) {
      var _props = this.props,
          rules = _props.rules,
          _props$errorMessages = _props.errorMessages,
          errorMessages = _props$errorMessages === undefined ? {} : _props$errorMessages,
          _props$attributeNames = _props.attributeNames,
          attributeNames = _props$attributeNames === undefined ? {} : _props$attributeNames;
      var values = this.state.values;

      if (!rules) return onClick(values);

      var runner = new _validatorjs2.default(values, rules, errorMessages);
      runner.setAttributeNames(attributeNames);

      if (runner.fails()) {
        return this.setState({ errors: runner.errors.errors });
      } else this.setState({ errors: {} });

      return onClick(values);
    }
  }, {
    key: 'validateOnBlurOrChange',
    value: function validateOnBlurOrChange(name, onChange) {
      if (onChange) onChange();

      var _props2 = this.props,
          rules = _props2.rules,
          _props2$errorMessages = _props2.errorMessages,
          errorMessages = _props2$errorMessages === undefined ? {} : _props2$errorMessages,
          _props2$attributeName = _props2.attributeNames,
          attributeNames = _props2$attributeName === undefined ? {} : _props2$attributeName;
      var _state = this.state,
          errors = _state.errors,
          values = _state.values;

      if (!rules || !rules[name]) return;

      var runner = new _validatorjs2.default(_defineProperty({}, name, values[name]), _defineProperty({}, name, rules[name]), errorMessages);
      runner.setAttributeNames(attributeNames);

      if (runner.fails() && values[name] && !onChange) {
        return this.setState({ errors: _extends({}, errors, runner.errors.errors) });
      }
      if (errors[name]) {
        return this.setState({ errors: _extends({}, errors, _defineProperty({}, name, null)) });
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(_ref4) {
      var target = _ref4.target;
      var values = this.state.values;

      values[target.name] = target.value;
      this.setState({ values: values });
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren(children) {
      var _this2 = this;

      return _react2.default.Children.map(children, function (child) {
        if (!child || !child.props) return child;

        var children = child.props.children;
        if (child.props.children && typeof child.props.children !== 'string') children = _this2.renderChildren(child.props.children);

        var _props$initialValues = _this2.props.initialValues,
            initialValues = _props$initialValues === undefined ? {} : _props$initialValues;
        var _state2 = _this2.state,
            values = _state2.values,
            errors = _state2.errors;
        var _child$props = child.props,
            name = _child$props.name,
            submit = _child$props.submit;

        if (name) return _react2.default.cloneElement(child, {
          children: children,
          onChange: function onChange(e) {
            return _this2.validateOnBlurOrChange(name, function () {
              return _this2.onChange(e);
            });
          },
          onBlur: function onBlur() {
            return _this2.validateOnBlurOrChange(name);
          },
          error: (0, _getError2.default)(errors, _this2.props.errors, name),
          value: values[name] || initialValues[name] || ''
        });

        if (child.props.submit) {
          var _child$props2 = child.props,
              _submit = _child$props2.submit,
              otherProps = _objectWithoutProperties(_child$props2, ['submit']);

          return _react2.default.createElement(child.type, _extends({}, otherProps, {
            children: children,
            onClick: function onClick() {
              return _this2.validate(child.props.onClick);
            }
          }));
        }
        return _react2.default.cloneElement(child, { children: children });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          children = _props3.children,
          rules = _props3.rules,
          errorMessages = _props3.errorMessages,
          attributeNames = _props3.attributeNames,
          initialValues = _props3.initialValues,
          props = _objectWithoutProperties(_props3, ['children', 'rules', 'errorMessages', 'attributeNames', 'initialValues']);

      return _react2.default.createElement(
        'div',
        props,
        this.renderChildren(children)
      );
    }
  }]);

  return Form;
}(_react2.default.Component);

exports.default = Form;